$MultitoolTotal = 0;

datablock AudioProfile(MultiToolFireSound)
{
	filename			= "base/data/sound/bodyRemove.wav";
	description			= AudioClosest3d;
	preload				= true;
};

datablock ParticleData(MultiToolSmokeParticle)
{
	dragCoefficient			= 3;
	gravityCoefficient		= -0.5;
	inheritedVelFactor		= 0.2;
	constantAcceleration		= 0.0;
	lifetimeMS			= 525;
	lifetimeVarianceMS		= 55;
	textureName			= "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin			= -500.0;
	spinRandomMax			= 500.0;
	colors[0]			= "0.5 0.5 0.5 0.9";
	colors[1]			= "0.5 0.5 0.5 0.0";
	sizes[0]			= 0.15;
	sizes[1]			= 0.15;

	useInvAlpha			= false;
};
datablock ParticleEmitterData(MultiToolSmokeEmitter)
{
	ejectionPeriodMS		= 3;
	periodVarianceMS		= 0;
	ejectionVelocity		= 1.0;
	velocityVariance		= 1.0;
	ejectionOffset			= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel			= 0;
	phiVariance			= 360;
	overrideAdvance			= false;
	particles			= "MultiToolSmokeParticle";
};

datablock ParticleData(MultiToolFlashParticle)
{
	dragCoefficient			= 3;
	gravityCoefficient		= -0.5;
	inheritedVelFactor		= 0.2;
	constantAcceleration		= 0.0;
	lifetimeMS			= 25;
	lifetimeVarianceMS		= 15;
	textureName			= "base/data/particles/star1";
	spinSpeed			= 10.0;
	spinRandomMin			= -500.0;
	spinRandomMax			= 500.0;
	colors[0]			= "0.0 0.0 1.0 0.9";
	colors[1]			= "0.0 1.0 0.0";
	sizes[0]			= 0.5;
	sizes[1]			= 1.0;

	useInvAlpha			= false;
};
datablock ParticleEmitterData(MultiToolFlashEmitter)
{
	ejectionPeriodMS		= 3;
	periodVarianceMS		= 0;
	ejectionVelocity		= 1.0;
	velocityVariance		= 1.0;
	ejectionOffset			= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel			= 0;
	phiVariance			= 360;
	overrideAdvance			= false;
	particles			= "MultiToolFlashParticle";
};


datablock DebrisData(MultiToolShellDebris)
{
	shapeFile			= "Add-Ons/Weapon_Gun/gunShell.dts";
	lifetime			= 2.0;
	minSpinSpeed			= -400.0;
	maxSpinSpeed			= 200.0;
	elasticity			= 0.5;
	friction			= 0.2;
	numBounces			= 3;
	staticOnMaxBounce		= true;
	snapOnMaxBounce			= false;
	fade				= true;
	gravModifier			= 2;
};

datablock ParticleData(MultiToolTrailParticle)
{
	dragCoefficient			= 3.0;
	windCoefficient			= 0.0;
	gravityCoefficient		= 0.0;
	inheritedVelFactor		= 0.0;
	constantAcceleration		= 0.0;
	lifetimeMS			= 200;
	lifetimeVarianceMS		= 0;
	spinSpeed			= 10.0;
	spinRandomMin			= -50.0;
	spinRandomMax			= 50.0;
	useInvAlpha			= false;
	animateTexture			= false;

	textureName			= "base/data/particles/thinring";

	colors[0]			= "0.0 1.0 0.0";
	colors[1]			= "0.0 0.0 1.0";
	sizes[0]			= 0.2;
	sizes[1]			= 0.4;
	times[0]			= 0.0;
	times[1]			= 1.0;
};

datablock ParticleEmitterData(MultiToolTrailEmitter)
{
	ejectionPeriodMS		= 2;
	periodVarianceMS		= 0;
	ejectionVelocity		= 0;
	velocityVariance		= 0;
	ejectionOffset			= 0;
	thetaMin			= 0.0;
	thetaMax			= 90.0;  
	particles			= MultiToolTrailParticle;
};

datablock ProjectileData(MultiToolProjectile)
{
	directDamage			= 0;
	directDamageType		= $DamageType::Gun;
	radiusDamage			= 0;
	damageRadius			= 0;
	radiusDamageType		= $DamageType::Gun;
	explosion			= spawnExplosion;
	particleEmitter			= MultiToolTrailEmitter;
	muzzleVelocity			= 65;
	velInheritFactor		= 1;
	armingDelay			= 0;
	lifetime			= 4000;
	fadeDelay			= 3500;
	bounceElasticity		= 0;
	bounceFriction			= 0;
	isBallistic			= true;
	gravityMod			= 0.0;
	hasLight			= true;
	lightRadius			= 3.0;
	lightColor			= "0 0 0.5";
};

datablock ProjectileData(MMWandProjectile : MultiToolProjectile)
{
	lifetime			= 250;
	fadeDelay			= 250;
	particleEmitter			= "";
	muzzleVelocity			= 20;
	hasLight			= false;
};

datablock ItemData(MMWandItem : WandItem)
{
	uiName				= "Multitool Wand";
	doColorShift			= true;
	colorShiftColor			= "0 0.710 0.250 1";
	image				= MMWandImage;
	canDrop				= true;
};

datablock ShapeBaseImageData(MMWandImage : WandImage)
{
	projectile			= MMWandProjectile;
	projectileType			= Projectile;
	doColorShift			= true;
	colorShiftColor			= MMWandItem.colorShiftColor;

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.01;
	stateTransitionOnTimeout[0]	= "Ready";
	stateEmitter[0]			= MultiToolTrailEmitter;
	stateEmitterTime[0]		= 1000;
	stateSound[0]			= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateEmitter[1]			= MultiToolTrailEmitter;
	stateEmitterTime[1]		= 1000;
	stateTransitionOnTriggerDown[1]	= "PreFire";
	stateAllowImageChange[1]	= true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};

//Gun Multitool
datablock ItemData(MultiToolItem)
{
	category			= "Tools";
	className			= "Tool";
	shapeFile			= "Add-Ons/Weapon_Gun/pistol.dts";
	rotate				= false;
	mass				= 1;
	density				= 0.2;
	elasticity			= 0.2;
	friction			= 0.6;
	emap				= true;
	uiName				= "MultiTool Gun";
	iconName			= "Add-Ons/Weapon_Gun/Icon_gun";
	doColorShift			= true;
	colorShiftColor			= MMWandItem.colorShiftColor;
	image				= MultiToolImage;
	canDrop				= true;
};

datablock ShapeBaseImageData(MultiToolImage)
{
	shapeFile			="Add-Ons/Weapon_Gun/pistol.dts";
	emap				= true;
	mountPoint			= 0;
	offset				= "0 0 0";
	eyeOffset			= 0;
	rotation			= eulerToMatrix( "0 0 10" );
	correctMuzzleVector		= true;
	className			= "WeaponImage";
	item				= MultiToolItem;
	ammo				= "";
	projectile			= MultiToolProjectile;
	projectileType			= Projectile;
	casing				= MultiToolShellDebris;
	shellExitDir			= "1.0 -1.3 1.0";
	shellExitOffset			= "0 0 0";
	shellExitVariance		= 15.0;	
	shellVelocity			= 7.0;
	melee				= false;
	armReady			= true;
	doColorShift			= true;
	colorShiftColor			= MMWandItem.colorShiftColor;

	stateName[0]			= "Activate";
	stateSound[0]			= weaponSwitchSound;
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";

	stateName[1]			= "Ready";
	stateSequence[1]		= "Ready";
	stateAllowImageChange[1]	= true;
	stateTransitionOnTriggerDown[1]	= "Fire";

	stateName[2]			= "Fire";
	stateSequence[2]		= "Fire";
	stateScript[2]			= "onFire";
	stateFire[2]			= true;
	stateEjectShell[2]		= true;
	stateWaitForTimeout[2]		= true;
	stateAllowImageChange[2]	= false;
	stateSound[2]			= MultiToolFireSound;
	stateEmitter[2]			= MultiToolFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateTimeoutValue[2]		= 0.14;
	stateTransitionOnTimeout[2]	= "Smoke";

	stateName[3]			= "Smoke";
	stateSequence[3]                = "Reload";
	stateEmitter[3]			= MultiToolSmokeEmitter;
	stateEmitterTime[3]		= 0.05;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTriggerUp[3]	= "Ready";
};

function MMWandImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function MMWandImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2,root);
}

function MultiToolImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}

function MultiFunction(%this,%obj,%col,%fade,%pos,%normal)
{
	call($MultitoolMode[%obj.client.MultiTool],%this,%obj,%col,%fade,%pos,%normal);
}

function MMWandProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	MultiFunction(%this,%obj,%col,%fade,%pos,%normal);
}

function MultiToolProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	MultiFunction(%this,%obj,%col,%fade,%pos,%normal);
}

package AddMultiTool
{
	function GameConnection::spawnPlayer(%this)
	{
		parent::spawnPlayer(%this);
		if(%this.MultiTool <= 0){%this.MultiTool = 0;}
		if(%this.automulti && %this.minigame <= 0)
		{
			for(%i=0;%i<5;%i++)
			{
				%this.player.tool[%i] = 0;
				messageClient(%this,'MsgItemPickup','',%i);
			}
			%this.player.tool[0] = MultiToolItem.getID();
			messageClient(%this,'MsgItemPickup','',0,MultiToolItem.getID());
			%this.player.tool[1] = MMWandItem.getID();
			messageClient(%this,'MsgItemPickup','',1,MMWandItem.getID());
		}
	}
};
ActivatePackage(AddMultiTool);

function giveItem(%Client,%Item,%Image)
{
	for(%i=0;%i<5;%i++)
	{
		switch$(%Client.player.tool[%i])
		{
			case %Item.getID(): return;
		}
		if(!%Client.player.tool[%i])
		{
			%Client.player.tool[%i] = %Item.getID();
			messageClient(%Client,'MsgItemPickup','',%i,%Item.getID());
			%Client.player.unMountImage(0);
			%Client.player.updateArm(%Image);
			%Client.player.mountimage(%Image,0);
			return;
		}
	}
}

function serverCmdMultitool(%Client,%Arg)
{
	if(%Client.minigame <= 0)
	{
		%Arg = strlwr(%Arg);
		switch$(%Arg)
		{
			case "gun":
				giveItem(%Client,MultiToolItem,MultiToolImage);
			case "wand":
				giveItem(%Client,MMWandItem,MMWandImage);
		}
	}
}

function serverCmdEnableMulti(%Client)
{
	switch(%Client.automulti)
	{
		case 0:
			%Client.automulti = 1;
			commandToClient(%Client,'centerprint',"Next time you respawn you'll have the multitools.",3);
		case 1:
			%Client.automulti = 0;
			commandToClient(%Client,'centerprint',"Next time you respawn you'll have your normal tools.",3);
	}
}

function serverCmdMM(%Client,%Dir)
{
	switch$(%Dir)
	{
		case "N":%Client.MultiTool++;
		case "P":%Client.MultiTool--;
	}
	if(%Client.MultiTool > $MultitoolTotal-1){%Client.MultiTool = 0;}
	else if(%Client.MultiTool < 0){%Client.MultiTool = $MultitoolTotal-1;}
	messageClient(%Client,'',"\c2"@$MultitoolMode[%Client.MultiTool]@"-Mode");
}

Exec("./Hammer.cs");
Exec("./Wrench.cs");
Exec("./Print.cs");
Exec("./PrintFill.cs");
Exec("./BrickEraser.cs");
Exec("./BrickKiller.cs");
Exec("./Decollision.cs");
Exec("./BrickOwner.cs");
Exec("./Measure.cs");